#ifndef PARAMBLOBRECORD_H
#define PARAMBLOBRECORD_H

#include "record.h"

class ParamBlobRecord : public Record {
  private:
	aitIndex index;
	gddAppFuncTable<ParamBlobRecord> funcTable;

  public:
	ParamBlobRecord(caServer&, const Param *p, const char *rn, const char *u);
	~ParamBlobRecord();

	epicsShareFunc aitEnum bestExternalType() const;
	epicsShareFunc unsigned maxDimension() const;
	epicsShareFunc aitIndex maxBound(unsigned int) const;
	gddAppFuncTableStatus readValue(gdd &);

	caStatus scan();
	caStatus read(const casCtx &ctx, gdd &value);
#if EPICS_RELEASE >= 314
	caStatus write(const casCtx &ctx, const gdd &value);
#else
	caStatus write(const casCtx &ctx, gdd &value);
#endif
};

#endif /* !PARAMBLOBRECORD_H */

