const PARAM_MAX_ARRAY_LEN = 128;
const PARAM_MAX_VALUE_LEN = 128;
const PARAM_MAX_NAME_LEN = 128;

typedef string ParamString<PARAM_MAX_VALUE_LEN>;

struct GetScalarArgs {
	unsigned long param;
	string name<PARAM_MAX_NAME_LEN>;
	string idx<PARAM_MAX_NAME_LEN>;
};

struct GetIntRes {
	int ret;
	int rows;
	unsigned long int value;
};

struct GetStringRes {
	int ret;
	int rows;
	ParamString value;
};

struct GetArrayArgs {
	unsigned long param;
	string name<PARAM_MAX_NAME_LEN>;
	string idx<PARAM_MAX_NAME_LEN>;
	int maxrows;
};

struct GetIntArrayRes {
	int ret;
	unsigned long int value<PARAM_MAX_ARRAY_LEN>;
};

struct GetStringArrayRes {
	int ret;
	ParamString value<PARAM_MAX_ARRAY_LEN>;
};

struct StoreIntArgs {
	unsigned long param;
	string name<PARAM_MAX_NAME_LEN>;
	string idx<PARAM_MAX_NAME_LEN>;
	unsigned long int value;
};

struct StoreStringArgs {
	unsigned long param;
	string name<PARAM_MAX_NAME_LEN>;
	string idx<PARAM_MAX_NAME_LEN>;
	ParamString value;
};

program RPCPARAMPROG {
        version RPCPARAMVERS {
                unsigned long CON(string) = 1;
                void DES(unsigned long) = 2;
                GetIntRes GETINT(GetScalarArgs) = 3;
                GetStringRes GETSTRING(GetScalarArgs) = 4;
                GetStringRes GETFILENAME(GetScalarArgs) = 5;
                GetIntArrayRes GETINTARRAY(GetArrayArgs) = 6;
                GetStringArrayRes GETSTRINGARRAY(GetArrayArgs) = 7;
                GetStringArrayRes GETFILENAMEARRAY(GetArrayArgs) = 8;
                int STOREINT(StoreIntArgs) = 9;
                int STORESTRING(StoreStringArgs) = 10;
        } = 1;
} = 0x20004711;
